--[[
	The following addon could have it's performance improved using better programming standards.
	I could do this myself, as most of this addon I wrote over a year ago, and I've improved quite a bit since then;
		I just don't have the time. :(
		
	Any questions or comments?
		david.tacker@gmail.com
]]

-- DEFAULT USER SETTINGS
TuaDB = TuaDB or {
	State = true,
	Movable = false,
	Banner = true,
	Scale = 1,
	Sound = true,
	Alert = true,
	Random = false,
	Countdown = 300,
}

--[[
	The Anchor frame, for positioning the banner text on the screen
]]
anchor = CreateFrame("Button", "TimeUntilAFKAnchor", UIParent)
anchor:SetMovable("true"); 
anchor:SetWidth(36); anchor:SetHeight(36)
anchor:RegisterForClicks("AnyDown")
anchor:SetPoint("Center")

anchor:SetScript("OnMouseDown", function() anchor:StartMoving() end)
anchor:SetScript("OnMouseUp", function() anchor:StopMovingOrSizing(); anchor:SetUserPlaced(true) end)
anchor:SetScript("OnDragStop", function() anchor:StopMovingOrSizing(); anchor:SetUserPlaced(true) end)
anchor:SetScript("OnLeave", function() GameTooltip:Hide(); anchor:SetUserPlaced(true) end)
anchor:SetScript("OnEnter", function()  GameTooltip:SetText("Time Until AFK Anchor:\n Left-click to drag\n Shift-click to hide"); GameTooltip:Show() end)
anchor:SetScript("PostClick", function() if IsShiftKeyDown() then TuaDB.Movable = false; anchor:Hide() end end)

anchor:SetBackdrop({
  bgFile = "Interface\Tooltips\UI-Tooltip-Background", 
  edgeFile = "Interface\Tooltips\UI-Tooltip-Border", 
  
  tile = true, tileSize = 16, edgeSize = 16,
  insets = { left = 5, right = 5, top = 5, bottom = 5}
})
anchor:SetBackdropColor(.1, .1, .1, 1)
anchor:SetBackdropBorderColor(.25, .25, .25, 1)

TimeUntilAFK = CreateFrame("Frame", "TimeUntilAFK", UIParent)
TimeUntilAFK_OptionsLoaded = false

--[[ 
	Local stuff to this addon
]]

local UpdateInterval	= 1			-- How often the update runs, in seconds
local DelayTime 	= 0				-- Used in the OnUpdate, to ensure the code is only ran once per interval
local Countdown			= 300		-- In seconds, 300 = 5 minutes
local SoundPlayed		= true		-- Has the sound been played yet?
local UntilAfkTempTime	= 0			-- Misc, set to GetTime() to determine length of idle
local pGUID = UnitGUID("player")	-- Setting this once, so it's not checked each time the event is fired

local function ResetTimer()
	Countdown = TuaDB.Countdown
	UntilAfkBanner:SetText("")
end

local function SecondsToTimeString(time)
    local myTime = tostring(math.floor(time % 60)).."sec "
    if time >= 60 then 
        time = time / 60
        myTime = tostring(math.floor(time % 60))..'min '..myTime
        if time >= 60 then
            time = time / 60
            myTime = tostring(math.floor(time % 24))..'h '..myTime
            if time >= 24 then
                time = time / 24
                myTime = tostring(math.floor(time))..'d '..myTime
            end
        end
    end
    return myTime
end

TimeUntilAFK_soundFiles = {
	"Sound\\Character\\BloodElf\\BloodElfFemaleBeg01.wav",
	"Sound\\Creature\\ThaneKorthazz\\KOR_NAXX_AGGRO.wav",
	"Sound\\Creature\\SuccubusVO\\SUCCUBUS_FUNNY.wav",
	"Sound\\Creature\\Strawman\\OzStrawmanSlay01.wav",
	"Sound\\Creature\\Skeram\\SkeramTheScreamsOf.wav",
	"Sound\\Creature\\Razuvious\\RAZ_NAXX_JOKE.wav",
	"Sound\\Creature\\Razuvious\\RAZ_NAXX_AGGRO02.wav",
	"Sound\\Creature\\Razorgore\\RazorgoreDeath.wav",
	"Sound\\Creature\\Ragnaros\\RagnarosSlay01.wav",
	"Sound\\Creature\\Ragnaros\\RagnarosReinforcements01.wav",
	"Sound\\Creature\\Patch1.7_VO_Lines\\HighPriestThekalTransform.wav",
	"Sound\\Creature\\Rajaxx\\RajaxxFearIS.wav",
	"Sound\\Creature\\Rajaxx\\RajaxxYouAreNot.wav",
	"Sound\\Creature\\SandfuryExecutioner\\SandfuryExecutionerAggro01.wav",
	"Sound\\Creature\\Wolf Rider\\WolfRiderPissed3.wav",
	"Sound\\Creature\\Wolf Rider\\WolfRiderReady1.wav",
	"Sound\\Doodad\\Narru_Crystal_Corrupted.wav",
	"Sound\\Creature\\LordVictorNefarius\\LordVictorNefariusGames.wav",
	"Sound\\Creature\\CThun\\CThunDeathIsClose.wav",
	"Sound\\Creature\\CThun\\CThunYouAreAlready.wav",
	"Sound\\Creature\\Dryad\\DryadReady1.wav",
	"Sound\\Creature\\Herod\\HerodWhirlwind01.wav",
	"Sound\\Creature\\HighInquisitorWhitemane\\HighInquisitorWhitemaneRes01.wav",
	"Sound\\Creature\\Kelthuzad\\KEL_NAXX_SUMMON.wav",
	"Sound\\Creature\\Mortar Team\\MortarTeamReady1.wav",
	"Sound\\Creature\\Mortar Team\\MortarTeamPissed8.wav",
	"Sound\\Creature\\Mortar Team\\MortarTeamPissed9.wav",
	"Sound\\Creature\\Nefarian\\NefarianSlay.wav",
	"Sound\\Creature\\Ossirian\\OssirianYouAre.wav",
	"Sound\\Creature\\Peon\\PeonBuildingComplete1.wav",
	"Sound\\Creature\\Varimathras\\VarimathrasGreeting01.wav",
	"Sound\\Creature\\Varimathras\\VarimathrasGreeting02.wav",
}

--[[
	Register all events that will be used
]]
TimeUntilAFK:RegisterEvent("ADDON_LOADED")
TimeUntilAFK:RegisterEvent("CHAT_MSG_SYSTEM")
TimeUntilAFK:RegisterEvent("CHAT_MSG_AFK")
TimeUntilAFK:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
TimeUntilAFK:RegisterEvent("LOOT_OPENED")

TimeUntilAFK:SetScript("OnEvent", function(self, event, ...)
	if (event == "ADDON_LOADED" and (...) == "TimeUntilAFK") then
		SlashCmdList["TimeUntilAFK"] = function()
			InterfaceOptionsFrame_OpenToCategory('Time Until AFK')
		end
		SLASH_TimeUntilAFK1 = "/timeuntilafk"
		SLASH_TimeUntilAFK2 = "/tua"

		TimeUntilAFK:PropigateOptions(self)
		TimeUntilAFK:SetScale(TuaDB.Scale)
		
	elseif (event == "CHAT_MSG_SYSTEM") then
		if not TuaDB.State then return end
		
		local msg = (select(1, ...))
		if msg == nil then return end
		
		if msg:lower():find("you are now away: afk") then
			UntilAfkTempTime = strsplit(".", GetTime())
			if TuaDB.Banner == true then UntilAfkBanner:SetText("Away from keyboard!") end
			TimeUntilAFK_TimerText:SetAlpha(1)
		
		elseif msg:lower():find("you are no longer away.") then
			local seconds = strsplit(".", GetTime()) - UntilAfkTempTime
			print("|cff3399FFTimeUntilAFK:|cffffffff You were flagged for "..SecondsToTimeString(seconds)..".")
			UntilAfkTempTime = 0; UntilAfkBanner:SetText()
		end
	
	elseif event == "COMBAT_LOG_EVENT_UNFILTERED" and (select(4, ...)) == pGUID then
		 ResetTimer() -- Resets the timer if the player attempts to cast any spell.
	
	elseif event == "LOOT_OPENED" then
		 ResetTimer()
	end
end)

--[[
-- Hook secure keybinds to reset the timer and clear the frame
]]
hooksecurefunc("JumpOrAscendStart", function () ResetTimer() end)
hooksecurefunc("TurnOrActionStart", function () ResetTimer() end)
hooksecurefunc("MoveBackwardStart", function () ResetTimer() end)
hooksecurefunc("MoveForwardStart", function () ResetTimer() end)
hooksecurefunc("StrafeLeftStart", function () ResetTimer() end)
hooksecurefunc("StrafeRightStart", function () ResetTimer() end)
hooksecurefunc("TurnRightStart", function () ResetTimer() end)
hooksecurefunc("TurnLeftStart", function () ResetTimer() end)
hooksecurefunc("ToggleAutoRun", function () ResetTimer() end)

TimeUntilAFK_TimerText = TimeUntilAFK:CreateFontString(nil, "BACKGROUND")
local text = _G['TimeUntilAFK_TimerText']
	text:SetFontObject(GameFontNormal)
	text:SetWidth(135); text:SetHeight(12)
	text:SetPoint("CENTER", TimeUntilAFKAnchor, "CENTER", 0, 0)
	text:SetJustifyH("MIDDLE")
	text:SetJustifyV("MIDDLE")

UntilAfkBanner = TimeUntilAFK:CreateFontString(nil, "BACKGROUND")
local banner = _G['UntilAfkBanner']
	banner:SetFontObject(GameFontNormalHuge)
	banner:SetWidth(1024); banner:SetHeight(80)
	banner:SetPoint("CENTER", UIParent, 0, 80)
	banner:SetJustifyH("MIDDLE")
	banner:SetJustifyV("MIDDLE")


TimeUntilAFK:SetScript("OnUpdate", function(self, elapsed)
    -- HIDES THE TIMER IF ADDON IS DISABLED
    if not TuaDB.State then TimeUntilAFKAnchor:Hide(); TimeUntilAFK:Hide(); return end

	local CurrentTime = GetTime()
	
    if (Countdown == 0) then ResetTimer() end
    
    -- COUNTDOWN CODE
	if (CurrentTime >= DelayTime) then
        DelayTime = CurrentTime + UpdateInterval
        Countdown = Countdown - UpdateInterval
        
        -- TIMER COUNTING UP OR DOWN, DEPENDING ON AFK STATUS
        if UnitIsAFK("player") then
            local temp = (GetTime() - UntilAfkTempTime)
            TimeUntilAFK_TimerText:SetText("|cffff3300 "..SecondsToTimeString(temp))
        else
            TimeUntilAFK_TimerText:SetText(SecondsToTimeString(Countdown))
        end
        
        -- ADJUST THE FRAME SCALE
		if TuaDB.Scale ~= nil then TimeUntilAFK:SetScale(TuaDB.Scale) end
 	end
    
    -- HIDE FRAME IF TIMER IS HIGHER THAN 4:30
    if (Countdown > 60 and not UnitIsAFK("player") and TuaDB.Movable == false) then
        TimeUntilAFK_TimerText:SetAlpha(0)
    elseif (Countdown < 60) then
        TimeUntilAFK_TimerText:SetAlpha(1)
    end
    
    -- SOUND CODE
    if TuaDB.Sound == true then
        if (Countdown > 45 and SoundPlayed and not UnitIsAFK("player")) then
            SoundPlayed = false
        elseif (Countdown < 45 and not SoundPlayed and not UnitIsAFK("player")) then
            if TuaDB.Alert == true then
				PlaySoundFile("Interface\\Addons\\TimeUntilAFK\\alert.mp3")			
			else
				PlaySoundFile(TimeUntilAFK_soundFiles[math.random(1, #(TimeUntilAFK_soundFiles))])
			end
			SoundPlayed = true
        end
    end
    
    -- SHOW FRAME IF IT IS DRAGGABLE
    if TuaDB.Movable == true then
        TimeUntilAFKAnchor:Show()
		TimeUntilAFK_TimerText:SetAlpha(1)
	else
		TimeUntilAFKAnchor:Hide()
    end
end)

