
-- #########################################
-- Inject my options configurations into the default WoW UI
function TimeUntilAFK:PropigateOptions(self) 
	local panel = CreateFrame("FRAME", "TimeUntilAFK_Options_Panel") 
 
	panel.name = "Time Until AFK"
	
	panel.okay = function() 
		for i, button in ipairs{panel:GetChildren()} do 
			button.origValue = storage[field] 
		end
		
		TimeUntilAFK:Show()
	end
	
	panel.cancel = function() 
		for i, button in ipairs{panel:GetChildren()} do 
			if button.Restore then
				button:Restore() 
			end 
		end
		
		TimeUntilAFK:Show()
	end

	panel.default = function()
		TuaDB.Scale = 1
		TuaDB.Sound = true
		TuaDB.Movable = false
		TuaDB.State = true
		TuaDB.Banner = true
		TuaDB.Alert = true
		TuaDB.Random = false
		
		InterfaceOptionsFrameOkay:Click()
		TimeUntilAFK:Show()
	end
	
	--[[
	local LoadMore = self:CreateButton("Load Options", panel, 155, 30)
	LoadMore:SetPoint('TOPLEFT', 10, -30)
	LoadMore:SetScript('OnClick', function()
		LoadMore:Hide()

		if TimeUntilAFK_OptionsLoaded == false then
			self:LoadOptions(self) 	-- Creates the options frame in the Addons List
			TimeUntilAFK_OptionsLoaded = true
		end
	end)
	]]

	local State = self:CreateCheckButton("Addon Enabled", panel, TuaDB, "State") 
	State:SetPoint('TOPLEFT', 10, -30) 
	State:SetChecked(TuaDB.State)
	
	local Header = State:CreateFontString(nil, "BACKGROUND")
	Header:SetFontObject(GameFontNormalHuge)
	Header:SetWidth(400)
	Header:SetHeight(12)
	Header:SetPoint('TOPLEFT', 10, 20)
	Header:SetJustifyH("LEFT")
	Header:SetJustifyV("TOP")
	Header:SetText(panel.name)

	local Sound = self:CreateCheckButton("Sound", panel, TuaDB, "Sound")
	Sound:SetPoint('TOPLEFT', 30, -52)
	Sound:SetChecked(TuaDB.Sound)
	
	local Alert = self:CreateRadioButton("Use alert.wav", panel, TuaDB, "Alert") 
	Alert:SetPoint('TOPLEFT', 50, -74)
	Alert:SetChecked(TuaDB.Alert)
	
	local Test1 = self:CreateButton("test .wav", panel, 85, 20)
	Test1:SetPoint('TOPLEFT', 280, -74)
	Test1:SetScript('OnClick', function() PlaySoundFile("Interface\\Addons\\TimeUntilAFK\\alert.mp3") end)
	
	local InGame = self:CreateRadioButton("Use a random in-game sound", panel, TuaDB, "Random") 
	InGame:SetPoint('TOPLEFT', 50, -96)
	InGame:SetChecked(TuaDB.Random)
	
	local Test2 = self:CreateButton("test rdm", panel, 85, 20)
	Test2:SetPoint('TOPLEFT', 280, -96)
	Test2:SetScript('OnClick', function() PlaySoundFile(TimeUntilAFK_soundFiles[math.random(1, #(TimeUntilAFK_soundFiles))]) end)
	
	Sound:SetScript('OnClick', function (self, button, down) 
				TuaDB.Sound = not TuaDB.Sound
				if not TuaDB.Sound then
					_G[Alert:GetName() .. 'Text']:SetTextColor(.5, .5, .5, 1); _G[Alert:GetName()]:EnableMouse(0)
					_G[InGame:GetName() .. 'Text']:SetTextColor(.5, .5, .5, 1); _G[InGame:GetName()]:EnableMouse(0)
					_G[Sound:GetName() .. 'Text']:SetTextColor(.5, .5, .5, 1)
					_G[Test1:GetName() .. 'Text']:SetTextColor(.5, .5, .5, 1); _G[Test1:GetName()]:EnableMouse(0)
					_G[Test2:GetName() .. 'Text']:SetTextColor(.5, .5, .5, 1); _G[Test2:GetName()]:EnableMouse(0)
				else
					_G[Alert:GetName() .. 'Text']:SetTextColor(1, 1, 1, 1); _G[Alert:GetName()]:EnableMouse(1)
					_G[InGame:GetName() .. 'Text']:SetTextColor(1, 1, 1, 1); _G[InGame:GetName()]:EnableMouse(1)
					_G[Sound:GetName() .. 'Text']:SetTextColor(1, 1, 1, 1)
					_G[Test1:GetName() .. 'Text']:SetTextColor(1, 1, 1, 1); _G[Test1:GetName()]:EnableMouse(1)
					_G[Test2:GetName() .. 'Text']:SetTextColor(1, 1, 1, 1); _G[Test2:GetName()]:EnableMouse(1)
				end
			end 
		)
	
	local Movable = self:CreateCheckButton("Movable", panel, TuaDB, "Movable") 
	Movable:SetPoint('TOPLEFT', 30, -118)
	Movable:SetChecked(TuaDB.Movable)
	
	local Banner = self:CreateCheckButton("Banner", panel, TuaDB, "Banner") 
	Banner:SetPoint('TOPLEFT', 30, -140)
	Banner:SetChecked(TuaDB.Banner)
	
	local DarkArea0 = self:CreateDarkArea("Scale and Timer", panel, 400, 125)
	DarkArea0:SetPoint('TOPLEFT', 5, -165)
	
	local Scale = self:CreateSlider("Scale", panel, .25, 3, .1, TuaDB, "Scale")
	Scale:SetPoint('TOPLEFT', 30, -210)
	Scale:SetScript('OnValueChanged', function(self, value)
		self.valText:SetText(format('%.1f', value))
		if not self.onShow then
			TuaDB.Scale = value
			TimeUntilAFK:SetScale(value)
		end
	end)
	Scale:SetValue(TuaDB.Scale)
	
	local Timer = self:CreateSlider("Timer", panel, 60, 1000, 10, TuaDB, "Countdown")
	Timer:SetPoint('TOPLEFT', 30, -240)
	Timer:SetScript('OnValueChanged', function(self, value)
		self.valText:SetText(format('%d', value))
		if not self.onShow then
			TuaDB.Countdown = value
		end
	end)
	Timer:SetValue(TuaDB.Countdown)
	
	InterfaceOptions_AddCategory(panel) 
end

function TimeUntilAFK:CreateButton(name, parent, width, height)
	local button = CreateFrame('Button', parent:GetName() .. name, parent, 'UIPanelButtonTemplate')
	button:SetWidth(width)
	button:SetHeight(height)
	
	local frame = _G[button:GetName() .. 'Text']
	frame:SetText(name)
	frame:SetTextColor(1, 1, 1, 1)

	return button 
end

function TimeUntilAFK:LoadOptions(self) 
	local panel = TimeUntilAFK_Options_Panel

	
end 

function TimeUntilAFK:CreateCheckButton(name, parent, storage, field)
	local button = CreateFrame('CheckButton', parent:GetName() .. name, parent, 'OptionsCheckButtonTemplate') 
	
	local frame = _G[button:GetName() .. 'Text']
	frame:SetText(name)
	frame:SetTextColor(1, 1, 1, 1)
	frame:SetFontObject(GameFontNormal)
	
	button:SetScript("OnShow", 
		function (self) 
			self:SetChecked(storage[field])
			self.origValue = storage[field]
		end 
	)
	button:SetScript("OnClick", 
		function (self, button, down) 
			storage[field] = not storage[field] 
		end 
	) 
	function button:Restore() 
		if self.origValue ~= nil then storage[field] = self.origValue end
	end 
 
	return button 
end


function TimeUntilAFK:CreateRadioButton(name, parent, storage, field)
	local button = CreateFrame('CheckButton', parent:GetName() .. name, parent, 'SendMailRadioButtonTemplate')	
	local frame = _G[button:GetName() .. 'Text']
	frame:SetText(name)
	frame:SetTextColor(1, 1, 1, 1)
	frame:SetFontObject(GameFontNormal)
	
	button:SetScript("OnShow", 
		function (self) 
			self:SetChecked(storage[field])
			self.origValue = storage[field]
		end 
	)

	button:SetScript("OnClick", 
		function (self, button, down)
			_G["TimeUntilAFK_Options_PanelUse alert.wav"]:SetChecked(nil)
			_G["TimeUntilAFK_Options_PanelUse a random in-game sound"]:SetChecked(nil)
			
			TuaDB.Alert = false
			TuaDB.Random = false
			
			this:SetChecked(1)
			storage[field] = not storage[field]
		end 
	)

	function button:Restore() 
		if self.origValue ~= nil then storage[field] = self.origValue end
	end 
	
	return button 
end

function TimeUntilAFK:CreateSlider(text, parent, low, high, step, storage, field)
	local name = parent:GetName() .. text
	local slider = CreateFrame('Slider', name, parent, 'OptionsSliderTemplate')
	slider:SetScript('OnMouseWheel', Slider_OnMouseWheel)
	slider:SetMinMaxValues(low, high)
	slider:SetValueStep(step)
	slider:EnableMouseWheel(true)

	_G[name .. 'Text']:SetText(text)
	_G[name .. 'Low']:SetText('')
	_G[name .. 'High']:SetText('')

	local text = slider:CreateFontString(nil, 'BACKGROUND')
	text:SetFontObject('GameFontHighlightSmall')
	text:SetPoint('LEFT', slider, 'RIGHT', 7, 0)
	slider.valText = text

	slider:SetScript('OnShow', function(self)
		self.origValue = storage[field]
		self.onShow = true
		self:SetValue(storage[field])
		self.onShow = nil
	end)
	
	function slider:Restore() 
		if self.origValue ~= nil then storage[field] = self.origValue end		
	end 
	
	return slider
end

function TimeUntilAFK:CreateDarkArea(text, parent, width, height)
	local name = parent:GetName() .. text
	local area = CreateFrame("Frame", name, parent)
	area:SetWidth(width)
	area:SetHeight(height)
	
	area:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background", 
								--edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",
								insets = { left = 5, right = 6, top = 6, bottom = 5 }}
	)
	
	local header = area:CreateFontString(nil, "BACKGROUND")
	header:SetFontObject(GameFontNormal)
	header:SetWidth(width)
	header:SetHeight(12)
	header:SetPoint('TOPLEFT', 10, -10)
	header:SetJustifyH("LEFT")
	header:SetJustifyV("TOP")
	header:SetText(text)
	
	return area
end
